\documentclass{scrarticle}
\usepackage{hyperref}
\usepackage{titling}
\pagenumbering{arabic}

\begin{document}
	\title{Integrating IoT in a Decentralized Renting Application} %TODO: Fill in project name
	\author{%TODO: Fill in your names
		Lieb, Alexander (Alexander.Lieb@online.de) 
		\and \\
		Rüdesheim, Lennard (lennard.ruedesheim@stud.tu-darmstadt.de)
		%TODO uncomment for more authors
		%	\and \\
		%	LastName3, FirstName3 (contact email)
		%	\and \\
		%	LastName4, FirstName4
	}
	%\author{team member 1\\ team member 2\\ team member 3} %TODO: Fill in your names
	\input{titlepage}
	\clearpage
	
	\section{Motivation and Goals}
	% What problem does your project solve? Who can benefit from your project? What are the goals that you plan to achieve? Try to summarize in about one page length. 
	The sharing economy is a business based on interactions between consumers of a platform. Popular examples for platforms in this market are Airbnb and Uber. They offer a service for users to rent their flat or  a driving service. This business model is rapidly growing in the last years and it is unclear how this step from a culture where consumers own assets to a culture where they share access to assets via platforms influences the society. \cite{MARTIN2016}

	In this setting the platform provider has the power to decide who has access to his services and  can demand significant fees for users. There is also a lack of privacy for the participants. \cite{Bogner16} An approach for this market to allow transactions between an owner of product and a renter without such a platform provider is to use a Decentralised App (DAPP) based on a smart contract on the Ethereum blockchain. 

We want to develop a DAPP, which enables users to rent their bikes. In this application we want to integrate an IoT device, so that the systems controls the lock of the bike and is able to locate it. The location of the bike can be used to determine the fee for borrowing and to make sure that the bike can only be returned at certain positions. The goal of the application is to make the rental system independent of a Trusted Third Party. In this way we avoid to pay fees to the platform provider and a user has more control of their data and information. \cite{Prasad18} 

Through the integration of the IoT device we want to make the effort for users to offer their bikes as small as possible.  For this the position of the bike can be used to reduce the effort that the provider of a bike has, when someone rented a bike and wants to return  it, because the bike owner defined allowed locations for returning it.

An additional goal is to minimize the gas costs of the application. This is important since the fees an user has to pay  for using the DAPP should be small compared to the costs using a traditional platform provider. 


	
	\newpage
	\section{Background}
        The idea to create a renting system using smart contracts is discussed in the community for a while now. Famous implemented concepts are Bogner et al. \cite{Bogner16} and Niya et al. \cite{Niya17}. While \cite{Bogner16} is concentrating on the technical aspects, \cite{Niya17} also mentions the legal aspects. Integrating IoT Devices into the blockchain is a hot research topic. An overview and evaluation of the competing architectures can be found in Pustišeka et al. \cite{Pus17}.

        Bogner et al. \cite{Bogner16} presents a DAPP, using Smart Contracts on the Ethereum blockchain. If a customer wants to rent a product, its QR code must be scanned and the payment happens via blockchain. In this implementation, the product as an IoT device is not part of the contract. An automatic unlocking or the possibility that the device reports how much it was used and therefore calculates the cost, is missing.

        Niya et al. \cite{Niya17} presents a concept, where the contract to rent an object is made legally valid and personal data is exchanged to ensure that the other person exists and can be identified in case something malicious happens. An android app is implemented, which can either run its own ethereum client or connect to an ethereum client running on a server. For exchanging personal data, device to device communication is used. The IoT device is not part of the contract. In the evaluation an estimation on the transaction fees is done. This is very helpful to see a very fundamental problem of blockchain rental systems. Renting a bicycle with this concept may cost more transaction fee than the actual service costs.

        Pustišeka et al. \cite{Pus17} divides the  IoT blockchain application development into two parts. The On-Chain part, where the Smart Contract and the payment happens, and the Front-End part, which is required for the user interface and by the IoT devices to interact with the On-Chain Part. The Front-End part is further divided into four possible architectures. The easiest one is to create a Stand-Alone node, where the IoT device runs a node. This enables the IoT device to directly interact with the blockchain but also requires the most resources and therefore might not be a good choice on constrained devices. The second approach is to let a server run the node including the key storage and the IoT device interacts with the corresponding server. This includes the security risk that anyone interacting with this server might also access the key store. Therefore the third possibility is to keep the key storage on the embedded device and send signed transactions to the node. This way is recommended by the authors. While the possibilities two and three work with the web3.js library, the last possibility is to use a proprietary communication protocol. This has the advantage to ignore the existing data formats and of being able to perfectly balance the application on the devices. 
        
	
	\newpage
	\section{Project management concept}
	%Explain your project management concept and your project plan. Try to sketch your management style in approximately two pages. Think about the following topics. However, feel free to reorder and combine them to develop a consistent management concept.

	%\subsection{Goals and accomplishment}
	
		%Formulate your goals more precisely and according to the SMART criteria.\\
		%How do you measure these goals?\\
	
	%\subsection{Project plan}
	
		%Please create a project plan. Think about defining a timeline, milestones, deadlines or working packages.
	
	%\subsection{Methodology, tools and software}
	
		%What is your project management methodology? Do you use the waterfall model, Scrum, Extreme Programming, ..., or some hybrid?
	
		%What tools and software are you planning to use for the project management (e.g., Trello, Slack, ...) and the project realization (e.g., a specific framework)?
	
	%\subsection{Team, responsibilities and communication}
	
		%What are the strength and the responsibilities of the team members (e.g., web design, management, ...)?
		
		%How are you planning to communicate (e.g., weekly meetings and via mails between the meetings)?
	
	%\subsection{Reflection}
	
		%How will you reflect your project management style?\\	
		%How will you handle deviations from your project plan and management concept?
	
	%\subsection{Motivation for the management concept}

		%What is the benefit of your management style?\\	
		%Why have you chosen this approach?
	For our project is an iterative and flexible process needed, since we expect unexpected events during the implementation. Examples are that the LTE stick might not be working as expected, the bike lock makes problems or the gas cost is too high and an improvement might suddenly has high priority. Therefore we decided to use agile methodologies, which are described in this chapter. 

	\subsection{Management Methodology}
	
	Our Management Methodology is based on Scrum and adapted to a two person team. We want to describe the features of our project in the form of User Stories. These User Stories are written from the perspective of an end user of the software and contains an acceptance criteria to make it measurable whether a User Stories is finished or not. To get an overview of the needed features the User Stories are stored in an Product Backlog. 
	
	We want to divide the project duration into sprints with the length of two weeks. Before each sprint we have a sprint planing meeting where we decide which User Stories we want to implement in the next sprint. These Users Stories are then moved to the Sprint Backlog. To make it easier to plan the sprint each User Story gets Story Points assigned with which we guess the effort of a User Story.

After a sprint we have a Sprint Review meeting in which the implemented features are presented and we decide which User Stories are completed. Additionally we do a Code Review for the newly added code. Five minutes of this meeting are reserved to exchange personal feedback about the Software Engineering Process. The last sprint is evaluated and improvements for the next sprint are discussed

To get an overview about the whole project we define milestones of the project. Each User Story is assigned to one of these milestones. In the Sprint Review meeting  we look at the Burndown Charts of these milestones to have the remaining work at a glance.

To store the User Stories and Milestones we use the Gitlab Issue Boards feature with which we can define lists for the Product Backlog, the Sprint Backlog, and for the finished User Stories, which are to be reviewed by the team. Gitlab also generates the Burndown charts for the milestones automatically.



	\subsection{Project Plan}

We defined three main milestones we want to achieve in the first sprints of our project. After the first sprint, which starts at the 27 April, we want have an working renting system. By that we mean that when an user posts an bike to the system an contract is deployed to the blockchain, the contract is registered in the system and it is possible to rent and reclaim a bike through it. 

Our second milestone is that our IoT device is able to show GPS information to a connected user, to get a connection to the internet via LTE stick and is able to open and close the lock. We want to achieve this milestone in the second sprint between May the 11th and 25th.

 After that we want to connect the IoT device to the contract, so that the contract is able to open and close the lock and gets the location and the travel distance of the bike from the IoT device.


When these milestones are achieved we want to minimize the gas costs of the application to make it more attractive for a customer to use it. This could be done by reducing the needed transactions with the blockchain or using a second layer between the owner and the renter of a bike.


	\subsection{Tools and software}

We want to use the Truffle framework \footnote{https://www.trufflesuite.com/} to build the DAPP. With this framework we can write smart contracts with the Solidity programming language and test and deploy them to the blockchain. To communicate between the client-side application and the Ethereum client we want to use the web3.js javascript library \footnote{https://web3js.readthedocs.io/}.

	\subsection{Motivation for the management methodology}
	 
With the chosen Management Methodology we can repeatedly inspect the actual working software after each sprint. Through this we can easily integrate new requirements into our project by adding new User Stories into the Product Backlog and assigning them to a milestone. The milestones helps us to have our goals for the project in mind and trough the Burndown charts we can earlier notice time problems for the project.  



The code reviews helps every team member to understand not only his added parts of the project, but the whole project. This makes it easier to help each other, if problems occur.


	
	\newpage
	\bibliographystyle{unsrt}
	\bibliography{ref}
	
\end{document}
